from peri import PeriBoard
from cocos.layer import *
from cocos.text import *
from cocos.scene import *
from cocos.sprite import Sprite
from cocos.director import *
from cocos.actions import *
from time import sleep
from layerLibrary import* 
from spriteClass import *
import pyglet
import random
from cocos.audio.effect import *

class IntroMainLayer(Layer):
    
    is_event_handler = True    
    def __init__(self):
        #Adding Flash for blink
        global boardManager
        super(IntroMainLayer,self).__init__()
        self.flashLayer = FlashBlinkLayer()
        self.flashLayer.newFlash = Sprite('Sprite/Flash/blank.jpg', position = (640,400))
        self.bg = BackgroundLayer('GUI/gameSplash.jpg')
        self.flashLayer.newFlash.scale = 3
        self.bg.bgImg.opacity = 0
        self.add(self.bg)
        self.bg.bgImg.do(FadeIn(2))
        self.flashLayer.newFlash.position = (640,400)
        self.flashLayer.add(self.flashLayer.newFlash)
        self.add(self.flashLayer)
        self.flashLayer.visible = False
        self.mainText = Label('Press any key to Start', font_size = 18, x = 525, y = 50)
        self.add(self.mainText)
        self.mainText.do(Repeat(Blink(1,0.5)))
        self.keys_pressed = set()
        self.schedule(self.loop)
        self.minLight = 1
        self.maxLight = 50
        self.buttIsPressed = False
        self.oldIsPressed = True
        self.isFlashed = False
        boardManager.setLed(0,1)
        self.count = 0
        self.lastLight = 0
    def loop(self,dt):
        
        if self.isFlashed == True:
            sleep(0.1)
            self.flashLayer.visible = True
            self.flashLayer.newFlash.visible = False
            self.isFlashed = False
            director.replace(Scene(MenuLayer()))
        self.buttIsPressed = boardManager.getSwitch()
        if self.oldIsPressed == False and self.buttIsPressed == True:
            self.isFlashed = True;
            self.flashLayer.visible = True;
        
        self.oldIsPressed = self.buttIsPressed
            
    def on_key_press(self,key,modifiers):
        self.keys_pressed.add(key)
    def on_key_release(self,key,modifiers):
        self.keys_pressed.remove(key)
        if str(key) == '32':
            director.replace(Scene(MenuLayer()))
    def resetProperty(self):
        self.buttIsPressed = False
        self.oldIsPressed = False
        self.isFlashed = False
    def gotoScene(self,Scene):
        self.resetProperty()
        director.replace(Scene)
    def getLightLevel(self):
        global boardManager
        if boardManager.getLight() > self.minLight and boardManager.getLight() < self.maxLight:
            return True
        else:
            return False        

class MenuLayer(Layer):
    is_event_handler = True
    def __init__(self):
        global boardManager
        super(MenuLayer,self).__init__();
        self.bg = BackgroundLayer('GUI/menuBG.png')
        self.humanLayer = Layer()
        self.bg.add(Sprite('GUI/gamePlayBG_Front.png', position = (640,400)))
        self.headText = Label('Create By:  Thanyamon Chidkruer  &  Warot Asawakowitkorn  (Chibi :3)', x = 720, y = 780)
        self.headText2 = Label('Blood Splatter  (2012)      Crazy Shooting game.', x = 900, y = 10)
        self.mainText = Label('Start', font_size = 36, x = 150, y = 300)
        self.mainTextSub = Label('Lets spill some blood', font_size = 18, x = 150, y = 250)
        self.mainText2 = Label('Instruction', font_size = 36, x = 150, y = 180)
        self.mainTextSub2 = Label('Some guide for a newbie', font_size = 18, x = 150, y = 130)
        self.menuArrow = Sprite('GUI/menuIndicator.gif')
        self.loader = Sprite('GUI/loader.png',position = (640,400))
        self.menuArrow.position = (100,300+18)
        self.flash = Sprite("Sprite/Flash/flash.jpg", position = (640,400))
        self.add(self.bg)
        self.add(self.humanLayer)
        self.add(self.flash)
        self.add(self.loader)
        self.add(self.mainText)
        self.add(self.mainTextSub)
        self.add(self.mainText2)
        self.add(self.mainTextSub2)
        self.add(self.menuArrow)
        self.add(self.headText)
        self.add(self.headText2)
        self.keys_pressed = set()
        self.schedule(self.loop)
        self.flash.do(FadeOut(0.4))
        self.loader.do(Repeat(RotateBy(360,1)))
        
        self.buttIsPressed = False
        self.oldIsPressed = True
        self.reloadIsDone = False
        self.oldReload = False
        
        self.selectedItem = 0
        self.enemySpeed = 12
        self.airSpeed = 24
        self.spawnLeft = random.randint(0,1)
        self.enemySpawnPosition = random.randint(200,500)
        self.randomEnemy = 7
        self.isEnemySpawned = False
        boardManager.setLed(0,0)
    def loop(self,dt):
        global boardManager, tutScene, introScene
        self.buttIsPressed = boardManager.getSwitch()
        self.reloadIsDone = boardManager.getReload()
        if self.oldIsPressed == False and self.buttIsPressed == True:
            if self.selectedItem == 0:
                director.replace(Scene(GamePlayLayer()))
            elif self.selectedItem == 1:
                director.replace(Scene(TutorialLayer()))
        if self.oldReload == False and self.reloadIsDone == True:
            if (self.selectedItem == 1):
                self.menuArrow.do(MoveTo((100,318),duration = 0.2))
                self.selectedItem = 0
            else:
                self.menuArrow.do(MoveTo((100,198),duration = 0.2))
                self.selectedItem = 1
        self.oldReload = self.reloadIsDone;
        self.oldIsPressed = self.buttIsPressed
    def on_key_press(self,key,modifiers):
        self.keys_pressed.add(key)
        if str(key) == '65362':
            self.menuArrow.do(MoveTo((100,318),duration = 0.2))
            self.selectedItem = 0
        elif str(key) == '65364':
            self.menuArrow.do(MoveTo((100,198),duration = 0.2))
            self.selectedItem = 1

    def on_key_release(self,key,modifiers):
        global tutScene, introScene
        self.keys_pressed.remove(key)
        if str(key) == '32' or str(key) == '65293':
            if self.selectedItem == 0:
                director.replace(Scene(GamePlayLayer()))
            elif self.selectedItem == 1:
                director.replace(Scene(TutorialLayer()))
                
class TutorialLayer(Layer):
    is_event_handler = True
    def __init__(self):
        super(TutorialLayer,self).__init__()
        self.sceneName =Label('Tutorial Scene\n  Press any key to go back to menu.', font_size = 18, x = 250, y = 400)
        self.flash = Sprite("Sprite/Flash/flash.jpg", position = (640,400))
        self.bg = BackgroundLayer("GUI/Tutorial.jpg")
        self.add(self.flash)
        self.add(self.bg)
        self.flash.do(FadeOut(0.4))
        self.schedule(self.loop)
        self.buttIsPressed = False
        self.oldIsPressed = True
        self.reloadIsDone = False
        self.oldReload = True
    def on_key_press(self,key,modifires):
        director.replace(Scene(MenuLayer()))
    def loop(self,dt):
        global boardManager
        self.buttIsPressed = boardManager.getSwitch()
        self.reloadIsDone = boardManager.getReload()
        if self.oldIsPressed == False and self.buttIsPressed == True:
            director.replace(Scene(MenuLayer()))
        self.oldReload = self.reloadIsDone;
        self.oldIsPressed = self.buttIsPressed
        
        
class GamePlayLayer(Layer):
    is_event_handler = True
    def __init__(self):
        global boardManager
        super(GamePlayLayer,self).__init__()
        self.keys_pressed = set()
        #self.bg = BackgroundLayer('gameplay_bg.jpg')
        self.flash = FlashBlinkLayer()
        self.flash.visible = False
        self.bg = BackgroundLayer('GUI/gamePlayBG.jpg')
        self.timeGUI = Sprite('GUI/time.png', position = (640,115))
        self.bulletGUI= Sprite('GUI/bulletInterface.png', position = (200,75))
        self.shottedGUI = Sprite('GUI/shotted.png', position = (850,110))
        self.bulletGUIList = []
        for i in range (0,8):
            self.bulletGUIList.append(Sprite('GUI/bullet.png', position = (176+i*22,71)))
            self.add(self.bulletGUIList[i])
        self.killedGUI = Sprite('GUI/killed.png', position = (850,40)) 
        self.shottedText = Label('Shot Taken: 0',font_name = 'Droid', font_size = 23, x = 890, y = 100, anchor_x = 'left', anchor_y = 'center')
        self.killedText = Label('Target Killed: 0',font_name = 'Droid', font_size = 23, x = 890, y = 30, anchor_x = 'left', anchor_y = 'center')
        self.reloadText = Label('Reloading...', font_name = 'Droid', font_size = 25, x = 180,y=95,anchor_x = 'left', anchor_y = 'center')
        self.reloadText.visible = False
        self.timeText = Label('',font_name = 'Droid', font_size = 27, x = 640, y = 90, anchor_x = 'center', anchor_y = 'center')
        
        self.add(self.flash)
        self.add(self.bg)
        self.add(self.reloadText)
        self.add(self.timeText)
        self.add(self.timeGUI) 
        self.add(self.bulletGUI)
        self.add(self.shottedGUI)
        self.add(self.killedGUI)
        self.add(self.shottedText)
        self.add(self.killedText)
        self.schedule(self.loop)
        
        self.minLight = 10
        self.maxLight = 40
        self.buttIsPressed = False
        self.oldIsPressed = True
        self.reloadIsPressed = False
        self.oldReload = False
        self.isFlashed = False
        self.testInput = False
        
        self.sleepDuration = 0.1
        self.time = 3000
        self.fireTime = 10
        self.fireInterval = 10
        self.reloadTime = 0
        self.reloadInterval = 60
        self.bullet = 8
        self.reloadTime = 200
        self.shot = 0
        self.hit = 0
        self.enemySpeed = 12
        self.airSpeed = 24
        self.spawnLeft = random.randint(0,1)
        self.enemySpawnPosition = random.randint(200,500)
        self.randomEnemy = 7
        self.isEnemySpawned = False
        self.enemyList = []
        self.flashList = []
        self.airList = []
        self.flashAirList = []
        self.glockFire = Effect('glockFire.wav')
        boardManager.setLed(0,1)
    def loop(self,dt):
        global scoreScene, boardManager
        
        if self.reloadTime <= self.reloadInterval:
            if self.reloadTime == self.reloadInterval:
                boardManager.setLed(0,1)
                self.bullet = 8
                self.reloadText.visible = False
                self.updateGUI()
            self.reloadTime += 1
        if self.fireTime <= self.fireInterval:
            self.fireTime += 1
            
        if self.isFlashed == True:
            self.glockFire.play()
            sleep(self.sleepDuration)
            #if self.getLightLevel() == True:
            if self.getLightLevel() == True:
                self.flash.visible = False
                self.isFlashed = False
                if self.randomEnemy != 7:
                    self.enemyList[0].visible = True
                    tempCorpse = Corpse(self.enemyList[0].x,self.enemyList[0].y,self.enemyList[0].left,self.enemyList[0].scale)
                    self.add(tempCorpse)
                    self.remove(self.enemyList.pop())
                    self.flash.remove(self.flashList.pop())
                else:
                    self.add(Explosion(self.airList[0].x,self.airList[0].y))
                    self.remove(self.airList.pop())
                    self.flash.remove(self.flashAirList.pop())
                self.resetRand()
                self.shot += 1
                self.hit += 1
            else:
                if self.randomEnemy != 7:
                    self.enemyList[0].visible = True
                else:
                    self.airList[0].visible = True
                self.flash.visible = False
                self.isFlashed = False
                self.shot += 1
            self.bullet -= 1
            self.fireTime = 0
            if self.bullet < 1:
                boardManager.setLed(0,0)
            self.updateGUI()
        else:
            self.minLight = boardManager.getLight()
    
        self.time -= 1
        self.timeText.element.text = str(self.time/60)
        if self.isEnemySpawned == False:
            self.isEnemySpawned = True
            if self.randomEnemy != 7:
                tempEnemy = Enemy(1540-(self.spawnLeft*1790),self.enemySpawnPosition,self.spawnLeft,False)
                #tempEnemy = Sprite('enemy.jpg', position = (1540-(self.spawnLeft*1790),self.enemySpawnPosition))
                tempEnemy.scale = 1.25-(self.enemySpawnPosition/800.0)
                self.add(tempEnemy)
                self.enemyList.append(tempEnemy)
                tempFlash = Sprite('Sprite/Flash/enemyFlash.jpg', position = (1540-(self.spawnLeft*1790),self.enemySpawnPosition))
                tempFlash.scale = 1.25-(self.enemySpawnPosition/800.0)
                self.flash.add(tempFlash)
                self.flashList.append(tempFlash)
            else:
                tempEnemy = Enemy(1540-(self.spawnLeft*1790),710,self.spawnLeft,True)
                self.add(tempEnemy)
                self.airList.append(tempEnemy)
                
                tempFlash = Sprite('Sprite/Flash/airEnemyFlash.jpg', position = (1540-(self.spawnLeft*1790),710))
                self.flash.add(tempFlash)
                self.flashAirList.append(tempFlash)
        else:
            if (self.spawnLeft == 1):
                self.enemySpeed = 12; self.airSpeed = 24
            elif (self.spawnLeft == 0):
                self.enemySpeed = -12; self.airSpeed = -24
            for enemy in self.enemyList:
                enemy.position = (enemy.position[0] + self.enemySpeed, enemy.position[1])
            for flashEnemy in self.flashList:
                flashEnemy.position = (self.enemyList[0].position[0]+1,self.enemyList[0].position[1]+1)
                #flashEnemy.position = self.enemyList[0].position
                if flashEnemy.position[0] <= -300 or flashEnemy.position[0] >= 1800:
                    self.remove(self.enemyList.pop())
                    self.flash.remove(self.flashList.pop())
                    self.resetRand()
            for enemy in self.airList:
                enemy.position = (enemy.position[0] + self.airSpeed, enemy.position[1])
            for flashEnemy in self.flashAirList:
                flashEnemy.position = (self.airList[0].position[0]+1, self.airList[0].position[1]+1)
                if flashEnemy.position[0] <= -300 or flashEnemy.position[0] >= 1800:
                    self.remove(self.airList.pop())
                    self.flash.remove(self.flashAirList.pop())
                    self.resetRand()
                
        self.buttIsPressed = boardManager.getSwitch()
        self.reloadIsPressed = boardManager.getReload()
        if self.oldIsPressed == False and self.buttIsPressed == True:
            if self.fireTime >= self.fireInterval and self.bullet >= 1:
                self.shootFunc()
        if self.oldReload == False and self.reloadIsPressed == True:
            if self.reloadTime > self.reloadInterval:
                boardManager.setLed(0,0)
                self.bullet = 0
                for bullet in self.bulletGUIList:
                    bullet.visible = False
                self.reloadTime = 0
                self.reloadText.do(Blink(4,1))
                self.updateGUI()
        for key in self.keys_pressed:
            if str(key) == '97':
                if self.fireTime >= self.fireInterval and self.bullet >= 1:
                    self.testInput = True
                    self.shootFunc()
            elif str(key) == '115':
                if self.fireTime >= self.fireInterval and self.bullet >= 1:
                    self.testInput = False 
                    self.shootFunc()
            elif str(key) == '114':     
                if self.reloadTime > self.reloadInterval:
                    self.bullet = 0
                    for bullet in self.bulletGUIList:
                        bullet.visible = False
                    self.reloadTime = 0
                    self.reloadText.do(Blink(4,1))
                    self.updateGUI()
        
        if (self.time < 0):
            boardManager.setLed(0,0)
            director.replace(Scene(HighScoreLayer(self.shot, self.hit)))
        self.oldIsPressed = self.buttIsPressed
        self.oldReload = self.reloadIsPressed
    def shootFunc(self):
        self.isFlashed = True
        self.flash.visible = True
        if self.randomEnemy != 7:
            self.enemyList[0].visible = False
        else:
            self.airList[0].visible = False
    def resetRand(self):
        self.isEnemySpawned = False
        self.spawnLeft = random.randint(0,1)
        self.enemySpawnPosition = random.randint(200,500)
        #self.randomEnemy = 7
        self.randomEnemy = random.randint(0,15)
    def updateGUI(self):
        self.shottedText.element.text = 'Shot Taken: ' + str(self.shot)
        self.killedText.element.text = 'Target Killed: ' + str(self.hit)
        if self.bullet != 8:
            self.bulletGUIList[self.bullet].visible = False
        else:
            for bullet in self.bulletGUIList:
                bullet.visible = True
    def on_key_press(self,key,modifiers):
        self.keys_pressed.add(key)
    def on_key_release(self,key,modifiers):
        self.keys_pressed.remove(key)
    def resetProperty(self):
        self.buttIsPressed = False
        self.oldIsPressed = False
        self.isFlashed = False
        
    def getLightLevel(self):
        global boardManager
        if boardManager.getLight() > self.minLight+5 and boardManager.getLight() < self.maxLight:
            return True
        else:
            return False  
            
class HighScoreLayer(Layer):
    is_event_handler = True
    def __init__(self, totalShot, totalTarget):
        super(HighScoreLayer,self).__init__()
        self.bg = BackgroundLayer('GUI/menuBG.png')
        self.bg.add(Sprite('GUI/gamePlayBG_Front.png', position = (640,400)))
        self.head = Label('Score Scene',font_size = 32, x = 250, y = 600)
        self.targetText = 'Target Hits: ' + str(totalTarget)
        self.shotText = 'Total Shots: ' + str(totalShot)
        self.oldIsPressed = True
        self.buttIsPressed = False
        self.oldReload = False
        self.reloadIsPressed = False
        if totalShot == 0:
            self.accuracy = 0;
        else:
            self.accuracy = totalTarget*100.0/ totalShot
        self.accuracyText = 'Accuracy: ' + str(round(self.accuracy,2)) + '%'
        self.totalScore = totalTarget*100 + self.accuracy*totalTarget
        self.scoreText = 'Total Score: ' + str(round(self.totalScore))
        self.time = 0
        self.targetLabel =Label(self.targetText, font_size = 20, x = 250, y= 520)
        self.shotLabel = Label(self.shotText, font_size = 20, x = 250, y = 460)
        self.accuracyLabel = Label(self.accuracyText, font_size = 20, x = 250 , y = 400)
        self.scoreLabel = Label(self.scoreText, font_size = 30, x = 250 , y=320)
        self.schedule(self.loop)
        self.add(self.head)
        self.add(self.bg)
    
    def loop(self,dt):
        global boardManager, tutScene, introScene
        self.time += 1
        self.buttIsPressed = boardManager.getSwitch()
        self.reloadIsDone = boardManager.getReload()
        self.shootEnable = False
        if self.oldIsPressed == False and self.buttIsPressed == True:
            director.replace(Scene(MenuLayer()))
            
        if (self.time == 60):
            self.add(self.targetLabel)
        if (self.time == 120):
            self.add(self.shotLabel)
        if (self.time == 180):
            self.add(self.accuracyLabel)
        if (self.time == 240):
            self.add(self.scoreLabel)
        if (self.time >= 300):
            self.shootEnable = True
        self.oldIsPressed = self.buttIsPressed
        self.oldReload = self.reloadIsPressed
            
if __name__ == "__main__":
    director.init(resizable = True, caption = "Game Test", fullscreen = True)
    minLight = 0
    maxLight = 0
    boardManager = PeriBoard()
    _introMainLayer = IntroMainLayer()
    
    introScene = Scene(_introMainLayer)
    _menuLayer = MenuLayer()
    menuScene = Scene(_menuLayer)
    gamePlayScene = Scene(GamePlayLayer())
    director.run(introScene)
    
    