from practicum import McuBoard

RQ_SET_LED    = 0
RQ_GET_SWITCH = 1
RQ_GET_LIGHT  = 2

####################################
class PeriBoard(McuBoard):

    ################################
    def setLed(self, led_no, led_val):
        '''
        Set status of LED led_no on peripheral board to led_val
        '''
        self.usb_write(RQ_SET_LED,led_no, led_val);

    ################################
    def setLedValue(self, value):
        '''
        Display value's 3 LSBs on peripheral board's LEDs
        '''
        x = value
        self.usb_write(RQ_SET_LED,0,x%2);
        x/=2
        self.usb_write(RQ_SET_LED,1,x%2);
        x/=2
        self.usb_write(RQ_SET_LED,2,x%2);

    ################################
    def getSwitch(self):
        '''
        Return a boolean value indicating whether the switch on the peripheral
        board is currently pressed
        '''
        if (self.usb_read(RQ_GET_SWITCH,length=1)[0]==1):
            return True
        else:
            return False

    def getReload(self):
         
        if (self.usb_read(3)[0] == 1):
            return True
        else:
            return False
    ################################

    def getLight(self):
        '''
        Return the current reading of light sensor on peripheral board
        '''
        (a,b)= self.usb_read(RQ_GET_LIGHT,length = 2)
        return (a+b*256)
